
/*
 *	H
 *	
 *	Copyright 2016 IS2T. All rights reserved.
 *	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef _HAL_K65
#define _HAL_K65

/* Includes ------------------------------------------------------------------*/

#include <stdint.h>
#include <stdio.h>

#include "fsl_common.h"
#include "fsl_adc16.h"
#include "fsl_dac.h"
#include "fsl_dmamux.h"
#include "fsl_edma.h"
#include "fsl_port.h"
#include "fsl_gpio.h"

#include "LLHAL_GPIO_impl.h"
#include "hal_k65_configuration.h"

/* Defines -------------------------------------------------------------------*/

/*
 * Available number of channels
 */
#ifndef ADC_NB_CHANNELS
#define ADC_NB_CHANNELS 5
#endif

/*
 * Global virtual MCU port
 */
#define HAL_K65_GPIO_PORT_MCU 0

/* Structs -------------------------------------------------------------------*/

/*
 * DAC data
 */
typedef struct
{
	DAC_Type* DACx;

} hal_k65_dac_data;

/*
 * MCU pin data
 */
typedef struct
{
	PORT_Type* PORTx;
	GPIO_Type* GPIOx;
	uint8_t GPIO_Pin;
	hal_k65_dac_data dac_data;
	int8_t adc_rank;
} hal_k65_gpio_data;

/*
 * List of ports used by this implementation
 */
typedef enum
{
	/*
	 * List of MCU ports used by this implementation
	 */
	LLHAL_GPIO_PORT_A = 1,
	LLHAL_GPIO_PORT_B = 2,
	LLHAL_GPIO_PORT_C = 3,
	LLHAL_GPIO_PORT_D = 4,
	LLHAL_GPIO_PORT_E = 5,

	/*
	 * List of specific ports used by this implementation
	 */
	LLHAL_GPIO_PORT_ELEVA = 64,
	LLHAL_GPIO_PORT_ELEVB = 65,
	LLHAL_GPIO_PORT_ELEVC = 66,
	LLHAL_GPIO_PORT_ELEVD = 67,
} HAL_GPIO_IMPL_Port;

/* API -----------------------------------------------------------------------*/

/*
 * Initialize specific implementation data (clocks etc.)
 */
void hal_k65_initialize(void);

/*
 * Fill the structure for the given port and pin
 */
int32_t hal_k65_get_gpio_data(int32_t port, int32_t pin, hal_k65_gpio_data* gpio);

/* EOF -----------------------------------------------------------------------*/

#endif // _HAL_K65
