/*
 * C
 *
 * Copyright 2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include "hal_K65.h"
#include "adc_manager_impl.h"

/* Fields --------------------------------------------------------------------*/

/*
 * Buffer used to store ADC converted values
 */
static __IO uint32_t converted_values[ADC_NB_CHANNELS];
edma_handle_t g_EDMA_Handle;

/* Private functions ---------------------------------------------------------*/

/* API -----------------------------------------------------------------------*/

int32_t adc_manager_initialize(void) {
	uint8_t adc_ID = 1;
	adc16_config_t adcConfig;

//	uint32_t* array_ptr = (uint32_t*) &converted_values;

	while (1) {
		ADC_Type* adcHandle;

		// get specific ADC data
		if (adc_manager_impl_get_data(adc_ID,
				&adcHandle) != HAL_GPIO_OK) {
			// no more ADC
			return HAL_GPIO_OK;
		}

		adcConfig.referenceVoltageSource = kADC16_ReferenceVoltageSourceVref;
		adcConfig.clockSource = kADC16_ClockSourceAsynchronousClock;
		adcConfig.enableAsynchronousClock = true;
		adcConfig.clockDivider = kADC16_ClockDivider4;
		adcConfig.resolution = kADC16_ResolutionSE12Bit;
		adcConfig.longSampleMode = kADC16_LongSampleCycle24;
		adcConfig.enableHighSpeed = false;
		adcConfig.enableLowPower = false;
		adcConfig.enableContinuousConversion = true;

		ADC16_Init(adcHandle, &adcConfig);
		ADC16_EnableHardwareTrigger(adcHandle, false);

		adc_manager_impl_configure_ranks(adc_ID, adcHandle);

		++adc_ID;
//		++array_ptr;
	}
}

void adc_manager_configure_rank(ADC_Type* adcHandle, uint32_t rank, uint32_t channel) {
	adc16_channel_config_t adcChannelConfig;
	adcChannelConfig.channelNumber = channel;
	adcChannelConfig.enableInterruptOnConversionCompleted = true;
	adcChannelConfig.enableDifferentialConversion = false;

	ADC16_SetChannelConfig(adcHandle, 0, &adcChannelConfig);
}

int32_t adc_manager_get_value(hal_k65_gpio_data* gpio)
{
	return ADC1->R[0];
//	return converted_values[gpio->adc_rank];
}
