/*
 * C
 *
 * Copyright 2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include "hal_k65.h"
#include "dac_manager_impl.h"

/* Fields --------------------------------------------------------------------*/

/*
 * Global common DAC timer channel configuration
 */
//static TIM_OC_InitTypeDef hal_dac_sConfig;

/*
 * Global common DAC timer handler.
 */
//static TIM_HandleTypeDef hal_dac_timer_handler;

/* API -----------------------------------------------------------------------*/

/*
 * A timer can drive several channels. So the initialization step is performed
 * at startup and only a start/stop action is made on each channel.
 */
int32_t dac_manager_initialize(void)
{
	dac_config_t dacConfigStruct;
	uint8_t dac_ID = 0;
	while(1)
	{
		// get specific DAC data
		hal_k65_dac_data data;
		if (dac_manager_impl_get_data(dac_ID, &data) != HAL_GPIO_OK)
		{
			// no more DAC timers
			return HAL_GPIO_OK;
		}

		DAC_GetDefaultConfig(&dacConfigStruct);
	    DAC_Init(data.DACx, &dacConfigStruct);
	    DAC_SetBufferReadPointer(data.DACx, 0U);

		++dac_ID;
	}
}

int32_t dac_manager_set_value(hal_k65_gpio_data* gpio, int32_t percentage)
{

	DAC_SetBufferValue(gpio->dac_data.DACx, 0U, (percentage * 0xFFF)/100);

	return HAL_GPIO_OK;
}
