
/*
 *	C
 *	
 *	Copyright 2016 IS2T. All rights reserved.
 *	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */


/* Includes ------------------------------------------------------------------*/

#include <stdint.h>
#include "lcd_manager.h"

#define FLEX_BASE_ADDRESS         0x60000000
#define FLEX_ADRESS_MASK          0x00010000

/* Globals -------------------------------------------------------------------*/
lcdCopyParameters_t copyParams;

/* Private functions ---------------------------------------------------------*/

/* API -----------------------------------------------------------------------*/

void LCD_MANAGER_initialize(void)
{
    /* Ungate the ports clocks */
    CLOCK_EnableClock(kCLOCK_PortB);
    CLOCK_EnableClock(kCLOCK_PortC);
    CLOCK_EnableClock(kCLOCK_PortD);

    /* FLEXBUS */
    PORTC->PCR[0]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD14
    PORTC->PCR[1]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD13
    PORTC->PCR[2]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD12
    PORTC->PCR[3]  = PORT_PCR_MUX(kPORT_MuxAlt5); // CLKOUT
    PORTC->PCR[4]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD11
    PORTC->PCR[5]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD10
    PORTC->PCR[6]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD9
    PORTC->PCR[7]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD8
    PORTC->PCR[8]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD7
    PORTC->PCR[9]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD6
    PORTC->PCR[10] = PORT_PCR_MUX(kPORT_MuxAlt5); // AD5
    PORTC->PCR[11] = PORT_PCR_MUX(kPORT_MuxAlt5); // RW
    PORTD->PCR[1]  = PORT_PCR_MUX(kPORT_MuxAlt5); // CS0
    PORTD->PCR[2]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD4
    PORTD->PCR[3]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD3
    PORTD->PCR[4]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD2
    PORTD->PCR[5]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD1
    PORTD->PCR[6]  = PORT_PCR_MUX(kPORT_MuxAlt5); // AD0
    PORTB->PCR[17] = PORT_PCR_MUX(kPORT_MuxAlt5); // AD16
    PORTB->PCR[18] = PORT_PCR_MUX(kPORT_MuxAlt5); // AD15
    
    SIM->CLKDIV1 &= ~SIM_CLKDIV1_OUTDIV3_MASK;
    SIM->CLKDIV1 |= SIM_CLKDIV1_OUTDIV3(0x1);
    SIM->SOPT2   |= SIM_SOPT2_FBSL(3);
    SIM->SCGC7   |= SIM_SCGC7_FLEXBUS_MASK;
    
    FB->CS[0].CSAR = FLEX_BASE_ADDRESS; // CS0 base address
    FB->CS[0].CSMR = FLEX_ADRESS_MASK | FB_CSMR_V_MASK; 
    FB->CS[0].CSCR = FB_CSCR_BLS_MASK | FB_CSCR_AA_MASK | (FB_CSCR_PS(2)) | (1<<10);
}

void LCD_MANAGER_LayerDefaultInit(void)
{
    lcdc_init();
}
