/*
 * C
 *
 * Copyright 2012-2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include "fsl_uart.h"
#include "fsl_port.h"
#include <stdio.h>

/* Defines -------------------------------------------------------------------*/

/* Globals -------------------------------------------------------------------*/

uint8_t putchar_initialized = 0;
uart_config_t config;

/* Private functions ---------------------------------------------------------*/

static void uart_init(void){
    /* Initialize UART2 pins */
    /* Ungate the port clock */
    CLOCK_EnableClock(kCLOCK_PortE);
    PORT_SetPinMux(PORTE, 16U, kPORT_MuxAlt3);
    PORT_SetPinMux(PORTE, 17U, kPORT_MuxAlt3);
  
    /*
     * config.baudRate_Bps = 115200U;
     * config.parityMode = kUART_ParityDisabled;
     * config.stopBitCount = kUART_OneStopBit;
     * config.txFifoWatermark = 0;
     * config.rxFifoWatermark = 1;
     * config.enableTx = false;
     * config.enableRx = false;
     */
    UART_GetDefaultConfig(&config);
    config.baudRate_Bps = 115200;
    config.enableTx = true;

    // UART2 operates from the bus clock
    UART_Init(UART2, &config, CLOCK_GetFreq(BUS_CLK));
}

/* Public functions ----------------------------------------------------------*/

int fputc(int ch, FILE *f){ 
	if(!putchar_initialized)
	{
		uart_init();
		putchar_initialized = 1;
	}
  
    UART_WriteBlocking(UART2, (uint8_t *)(&ch), sizeof(uint8_t));
	return ch;
}

