# Copyright 2016 IS2T. All rights reserved.
# For demonstration purpose only
# IS2T PROPRIETARY. Use is subject to license terms.

I) Introduction
===============

	This document describes how to build the TWRK65F180M-[example]-CM4hardfp_GCC48 Java Platform 
	(JPF) template and how to launch a Java application on this JPF. 
	
II) Content Description
=======================

	This JPF template is split into multiple MicroEJ projects:
	
	- TWRK65F180M-[example]-CM4hardfp_GCC48-configuration:
		Contains the JPF configuration description. Some modules are described in 
		a specific sub-folder /<module> with some optional configuration files 
		(<module>.properties and / or <module>.xml).
	
	- TWRK65F180M-[example]-CM4hardfp_GCC48-bsp:
		Contains empty low level C file (LL*.c) to implement for a specific 
		board and a main.c template. 
		
	- TWRK65F180M-[example]-CM4hardfp_GCC48-[version]
		This project is created once the JPF is built. 
		It contains a JPF, ready to be linked into the Board Support Package (BSP) 
		project.
		
	- TWRK65F180M-[example]-CM4hardfp_GCC48-fp:
		This front panel project is updated once the JPF is	built. It contains 
		a template board description with LCD, buttons... and images for the simulator.
		
	
III) Launching Example
======================

	1) JPF build
	
		First step is to build a JPF from JPF architecture CM4. 
		
		Build may be less or more complex, depending on the set	of libraries 
		that will be provided by the JPF. Typical build steps are:
			- JPF instantiation,
			- modules selection (native stacks, Java libraries etc.).
		
		Procedure:
			- For each module that will be included in the JPF
			([example]-configuration/<module>), update the <module>.properties 
			and optional <module>.xml files.
			- Open the file [example]-configuration/example_[toolchain].platform. In the Content
			view, check/uncheck the required modules for the JPF.
			- Launch the platform build clicking on the link "Build Platform" in
			the overview -> Build section.
			- Once the platform is built, the [example]-[version] project is created 
			  in the workspace.
		
	2) Java Application build 
	
		Second step is to generate Java application from the newly created JPF.
			
		Procedure:
			- Click on File > New > Java Example
			- Select TWRK65F180M-[example]-CM4hardfp_GCC48 JPF
			- Select one of the available example
			- Click on Next > Finish
			- In the Package Explorer, open the folder Java example project > launches.
			- Right-click on [example] EmbJPF.launch file 
			- Select Run As > [example] EmbJPF.
			- Once MicroEJ launch is executed, the generated object file is available 
			  in [workspace]/.microej/[CPU architecture and compiler]/application/microejapp.o.

		
	3) Final Application build
	
		Last step is to create a Board Support package project, compile 
		it and link it with the Java application, and program the final application 
		binary on the board.
		